/*------------------------------------------------------------*/
/* filename -       tscreen.cpp                               */
/*                                                            */
/* function(s)                                                */
/*                  TScreen member functions                  */
/*------------------------------------------------------------*/
/*
 *      Turbo Vision - Version 2.0
 *
 *      Copyright (c) 1994 by Borland International
 *      All Rights Reserved.
 *
 */

#ifdef      __GRAPHICS__
#include	<graphics.h>
#endif

#define Uses_TEvent
#define Uses_TScreen
#define Uses_THardwareInfo
#include <tvision\tv.h>

#if !defined( __FLAT__ ) && !defined( __DOS_H )
#include <dos.h>
#endif  // __DOS_H

ushort _NEAR TScreen::startupMode 		= 0xFFFF;
ushort _NEAR TScreen::startupCursor 	= 0;
ushort _NEAR TScreen::screenMode 		= 0;
uchar _NEAR TScreen::screenWidth 		= 0;
uchar _NEAR TScreen::screenHeight 		= 0;
Boolean _NEAR TScreen::hiResScreen 		= False;
Boolean _NEAR TScreen::checkSnow 		= True;
ushort * _NEAR TScreen::screenBuffer;
ushort _NEAR TScreen::cursorLines 		= 0;
Boolean _NEAR TScreen::clearOnSuspend 	= True;

//ushort _NEAR  TScreen::altVideoMode     = altGraphics;
ushort _NEAR  TScreen::altVideoMode       = altNone;
//ushort _NEAR  TScreen::altVideoMode		= altBios;
#ifdef      __GRAPHICS__
char TScreen::szBGIPath[MAXPATH]        = "\\BORLANDC\\BGI";
#endif

ushort TDisplay::getCursorType()
{
#if defined( __FLAT__ )
    return THardwareInfo::getCaretSize();
#else
    uchar start, end, base = 8;
    ushort result;

    _AH = 3;
    _BH = 0;
    videoInt();

    start = _CH;
    end = _CL;

    if( _CX == 0x2000 )
        return 0;

    if( isEGAorVGA() )
	{
        _AX = 0x1130;
        _BL = 0;
        videoInt();
        base = _CL;
    }

    start = (ushort) start * 100 / base;
    end = (ushort) end * 100 / base;

    result = (start << 8) + end;
    return result;
#endif
}

#if !defined( __FLAT__ )
int TDisplay::isEGAorVGA(void)
{
    _BL=0x10;
    _AH=0x12;
    videoInt();
    return _BL != 0x10;
}
#endif

void TDisplay::setCursorType( ushort ct )
{
#if defined( __FLAT__ )
    THardwareInfo::setCaretSize( ct & 0xFF );
#else
    uchar start, end, base = 8;

    if( ct == 0 )
        _CX = 0x2000;
    else
        {
        start = ct >> 8;
        end = ct & 0xFF;
/*
        start = ct & 0xFF;
        end = ct >> 8;
*/
        if( isEGAorVGA() )
            {
            _AX = 0x1130;
            _BL = 0;
            videoInt();
            base = _CL;
            }

        start = ((ushort) start * base + 50) / 100;
        end = ((ushort) end * base + 50) / 100;

        _CH = start;
        _CL = end;
        }
    _AH = 1;
    videoInt();
#endif
}

void TDisplay::clearScreen( uchar w, uchar h )
{
#if defined( __FLAT__ )
    THardwareInfo::clearScreen( w, h );
#else
    _BH = 0x07;
    _CX = 0;
    _DL = w;
    _DH = h - 1;
    _AX = 0x0600;
    videoInt();
#endif
}

#pragma warn -asc

#if !defined( __FLAT__ )
void TDisplay::videoInt()
{

I   PUSH    BP
I   PUSH    ES
I   INT     10h
I   POP     ES
I   POP     BP

}
#endif

#pragma warn .asc

ushort TDisplay::getRows()
{
#if defined( __FLAT__ )
    return THardwareInfo::getScreenRows();
#else
    _AX = 0x1130;
    _BH = 0;
    _DL = 0;
    videoInt();
    if( _DL == 0 )
        _DL = 24;
    return _DL + 1;
#endif
}

ushort TDisplay::getCols()
{
#if defined( __FLAT__ )
    return THardwareInfo::getScreenCols();
#else
    _AH = 0x0F;
    videoInt();
    return _AH;
#endif
}

ushort TDisplay::getCrtMode()
{
#if defined( __FLAT__ )
    return THardwareInfo::getScreenMode();
#else
    _AH = 0x0F;
    videoInt();
    ushort mode = _AL;

    /*
    if( getRows() > 25 )
        mode |= smFont8x8;
    */

    // EFW - Only change fonts if screen rows > 25 AND mode = smCO80
    if( getRows() > 25  && mode == smCO80)
        mode |= smFont8x8;

    return mode;
#endif
}

#pragma argsused
void TDisplay::setCrtMode( ushort mode )
{
#if defined( __FLAT__ )
    THardwareInfo::setScreenMode( mode );
#else
    ushort eflag = THardwareInfo::getBiosEquipmentFlag() & 0xFFCF;
    eflag |= (mode == smMono) ? 0x30 : 0x20;
	THardwareInfo::setBiosEquipmentFlag( eflag );
    THardwareInfo::setBiosVideoInfo( THardwareInfo::getBiosVideoInfo() & 0x00FE );

    _AH = 0;
    _AL = mode;
    videoInt();

    if( (mode & smFont8x8) != 0 )
        {
        _AX = 0x1112;
        _BL = 0;
        videoInt();

        if( getRows() > 25 )
            {
            THardwareInfo::setBiosVideoInfo( THardwareInfo::getBiosVideoInfo() | 1 );

			_AH = 1;
            _CX = 0x0607;
            videoInt();

            _AH = 0x12;
            _BL = 0x20;
            videoInt();
			}
		}
#endif
}

#ifdef      __GRAPHICS__
extern unsigned char shadowAttr;

#ifndef	HIBYTE(x)
#define HIBYTE(x) ( ((x) >> 8) & 0xFF )
#endif

#ifndef	LOBYTE(x)
#define LOBYTE(x) ( (x) & 0xFF )
#endif

#ifndef	BGATTR(x)
#define BGATTR(x) ( ((HIBYTE(x)) >> 4) & 0x0F )
#endif

#ifndef	FGATTR(x)
#define FGATTR(x) ( (HIBYTE(x)) & 0x0F )
#endif

unsigned char TDisplay::strbuf[100];

// function: paintBkgd
// declaration:
//	short paintBkgd( short ix, short iy, short max, ushort *buf );
// where:
//		ix  = start horizontal position (in pixels).
//		iy  = start vertical position (in pixels).
//		max = the length of buf (in words).
//		buf = the char/attr buffer.
// paintBkgd() searches buf for the maximum number of entries that have the
//	same background color (up to max), then paints that background 'bar'
//	to the screen at (ix,iy). It is assumed that the width and height of
//	each character is 8x8 pixels. Returns the number of entries whose
//	background was painted.

short TDisplay::gfxPaintBkgd( short ix, short iy, short max, ushort *buf )
{
	uchar attr = BGATTR(*buf);
	short count = 0;
	while( count < max && BGATTR(buf[count]) == attr )
		count++;
	setfillstyle( SOLID_FILL, attr );
	bar( ix, iy, ix+(count << 3)-1, iy+7 );
	return count;
}

// function: paintFrgd
// declaration:
//	short paintFrgd( short ix, short iy, short max, ushort *buf );
// where:
//		ix  = start horizontal position (in pixels).
//		iy  = start vertical position (in pixels).
//		max = the length of buf (in words).
//		buf = the char/attr buffer.
// paintFrgd() skips leading spaces in buf's char data, then searches buf
//	for the maximum number of entries that have the same foreground color
//	(up to max), then paints this string to the screen at (ix,iy). Returns
//	the number of characters (including the leading spacing) that was
//	painted.

short TDisplay::gfxPaintFrgd( short ix, short iy, short max, ushort *buf )
{
	uchar attr;
	short fat = 0, count = 0;
	char *ptr = strbuf;

	while( max > 0 && LOBYTE(*buf) == ' ' )
	{
		max--;
		buf++;
		ix += 8;
		fat++;
	}

	attr = FGATTR(*buf);
	while( count < max && FGATTR(buf[count]) == attr )
	{
		*ptr = LOBYTE(buf[count]);

		if( *ptr == ' ' )
			break;

		ptr++;
		count++;
	}

	*ptr = 0;
	setcolor(attr);
	outtextxy( ix, iy, strbuf );
	return count+fat;
}

// function: altWriteMethod
// declaration:
//	void altWriteMethod( short x, short y, short wid, ushort *buf,
//								short sflag );
// where:
//		x     = start horizontal position (in chars) : 0-based.
//		y     = start vertical position (in chars) : 0-based.
//		wid   = the length of buf (in words).
//		buf   = the char/attr buffer.
//		sflag = 0 if the attr entries of buf should be used; <> 0 if
//				shadowAttr (extern) should be the attribute.
// When alternative write method is enable, this function is used to write
//	the TV char/attr data to the screen.

void TDisplay::gfxWrite( short x, short y, short wid, ushort *buf, short sflag )
{
	char *ptr = strbuf;
	unsigned short far *pbuf;
	short iw, count, ix, iy;

	// Its a little involved to ensure that the mouse cursor needs to be
	// hidden - and the slowness of this graphics writing doesn't ensure
	// that the mouse won't move into the paint region while we're writing
	// so I just hide it every time.
	TMouse::hide();

	// Paint the background colors.

	if( !sflag )		// use the attribute data in buf.
	{
		pbuf = buf;
		iw = wid;
		ix = x << 3;
		iy = y << 3;

		while( iw > 0 )
		{
			count = gfxPaintBkgd( ix, iy, iw, pbuf );
			ix += (count << 3);
			pbuf += count;
			iw -= count;
		}
	}
	else				// use shadowAttr attribute.
	{
		setfillstyle( SOLID_FILL, (shadowAttr >> 4) );
		bar( x << 3, y << 3, ((x+wid-1) << 3)-1, ((y+1) << 3)-1 );
	}

	// Paint the foreground characters.

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );

	if( !sflag )		// use the attribute data in buf.
	{
		pbuf = buf;
		iw = wid;
		ix = x << 3;
		iy = y << 3;
		while( iw > 0 )
		{
			count = gfxPaintFrgd( ix, iy, iw, pbuf );
			ix += (count << 3);
			pbuf += count;
			iw -= count;
		}
	}
	else				// use shadowAttr attribute.
	{
		for( count = 0; count < wid; count++ )
			*ptr++ = LOBYTE(buf[count]);
		*ptr = 0;
		setcolor( shadowAttr & 0x0F );
		outtextxy( x << 3, (y << 3), strbuf );
	}

	// Restore the mouse.
	TMouse::show();
}

// function: paintChars
// declaration:
//	short paintChars( short x, short y, short max, ushort *buf );
// where:
//		x   = start column (in chars) : 0-based.
//		y   = row (in chars) : 0-based.
//		max = max length of buf.
//		buf = char/attr buffer.
// paintChars() optimizes BIOS calls by searching buf for all the entries
//	(up to max) that have the same character and attribute, then using
//	the video BIOS (interrupt 10h) to draw these chars on the screen.
//	Returns the number of entries printed.

short TDisplay::biosPaintChars( short x, short y, short max, ushort *buf )
{
	ushort item = *buf;
	short count = 0;

	while( count < max && buf[count] == item )
		count++;

	// Move the cursor to the starting location.
	_BH = 0;
	_DH = (uchar)y;
	_DL = (uchar)x;
	_AH = 2;
	geninterrupt(0x10);

	// print 'count' copies of item to the screen.
	uchar ch = (uchar)LOBYTE(item);
	uchar attr = (uchar)HIBYTE(item);
	_CX = count;
	_BL = attr;
	_BH = 0;
	_AL = ch;
	_AH = 9;
	geninterrupt(0x10);
	return count;
}

// function: paintSChars
// declaration:
//	short paintSChars( short x, short y, short max, ushort *buf );
// where:
//		x   = start column (in chars) : 0-based.
//		y   = row (in chars) : 0-based.
//		max = max length of buf.
//		buf = char/attr buffer.
// paintSChars() optimizes BIOS calls by searching buf for all the entries
//	(up to max) that have the same character, then using the video BIOS
//	(interrupt 10h) to draw these chars on the screen using the shadowAttr
//	attribute. Returns the number of entries printed.

short TDisplay::biosPaintSChars( short x, short y, short max, ushort *buf )
{
	ushort item = *buf;
	ushort theChar = LOBYTE(item);
	short count = 0;

	while( count < max && LOBYTE(buf[count]) == theChar )
		count++;

	_BH = 0;
	_DH = (uchar)y;
	_DL = (uchar)x;
	_AH = 2;
	geninterrupt(0x10);

	uchar ch = (uchar)theChar;
	uchar attr = (uchar)shadowAttr;
	_CX = count;
	_BL = attr;
	_BH = 0;
	_AL = ch;
	_AH = 9;
	geninterrupt(0x10);
	return count;
}

// function: altWriteMethod
// declaration:
//	void altWriteMethod(short x, short y, short wid, ushort *buf,
//						short sflag);
// where:
//		x     = start column (in chars) : 0-based.
//		y     = row (in chars) : 0-based.
//		wid   = size of buf.
//		buf   = char/attrib data buffer.
//		sflag = 0 if attrib in buf should be used, <>0 if shadowAttr should
//				be used.

void TDisplay::biosWrite( short x, short y, short wid, ushort *buf, short sflag )
{
	ushort *pbuf;
	short iw, count;
	ushort oldpos, oldshape;

	// Save the old cursor shape/position.
	_BH = 0;
	_AH = 3;
	geninterrupt(0x10);
	oldpos = _DX;
	oldshape = _CX;

	// Hide the cursor
	_CX = 0x2020;
	_AH = 1;
	geninterrupt(0x10);

	if( !sflag )	// use attrib data in buf.
	{
		pbuf = buf;
		iw = wid;
		while( iw > 0 )
		{
			count = biosPaintChars( x, y, iw, pbuf );
			x += count;
			pbuf += count;
			iw -= count;
		}
	}
	else			// use shadowAttr.
	{
		pbuf = buf;
		iw = wid;
		while( iw > 0 )
		{
			count = biosPaintSChars( x, y, iw, pbuf );
			x += count;
			pbuf += count;
			iw -= count;
		}
	}

	// Restore the cursor position.
	_DX = oldpos;
	_BH = 0;
	_AH = 2;
	geninterrupt(0x10);

	// Un-hide the cursor.
	_CX = oldshape;
	_AH = 1;
	geninterrupt(0x10);
}

void TScreen::altWriteMethod( short x, short y, short wid, ushort *buf, short sflag )
{
	switch(altVideoMode)
	{
		case	altBios:
			TDisplay::biosWrite( x, y, wid, buf, sflag );
			break;
		case	altGraphics:
			TDisplay::gfxWrite( x, y, wid, buf, sflag );
			break;
		default:
			break;
	}
}
#else
#pragma argsused
void TScreen::altWriteMethod( short x, short y, short wid, ushort *buf, short sflag )
{
}
#endif

TScreen::TScreen()
{

	startupMode = getCrtMode();
    startupCursor = getCursorType();

#if defined(__FLAT__)
    screenBuffer = THardwareInfo::allocateScreenBuffer();
#endif

	setCrtData();

#ifdef  __GRAPHICS__

	if(altVideoMode==altGraphics)
	{
		int gdriver = EGA;
		int gmode = EGAHI;

		initgraph( &gdriver, &gmode, szBGIPath );
		if( graphresult() != grOk )
			return;

		TScreen::screenHeight = getmaxy() >> 3;
		TMouse::setRange( TScreen::screenWidth-1, TScreen::screenHeight );
		TMouse::show();
	}
#endif
}

void TScreen::resume()
{
    startupMode = getCrtMode();
    startupCursor = getCursorType();
    if (screenMode != startupMode)
        setCrtMode( screenMode );
    setCrtData();
}

TScreen::~TScreen()
{
    suspend();
#if defined( __FLAT__ )
    THardwareInfo::freeScreenBuffer( screenBuffer );
#endif

#ifdef  __GRAPHICS__
	if(altVideoMode==altGraphics)
		closegraph();
#endif
}

void TScreen::suspend()
{
    if( startupMode != screenMode )
        setCrtMode( startupMode );
    if (clearOnSuspend)
      clearScreen();
    setCursorType( startupCursor );
}

#pragma argsused
ushort TScreen::fixCrtMode( ushort mode )
{
#if defined( __FLAT__ )
    if( THardwareInfo::getPlatform() != THardwareInfo::plDPMI32 )
        {
        mode = (mode & smFont8x8) ? smCO80 | smFont8x8 : smCO80;
        return mode;
        }
#endif
    // Modified - EFW - Thu 12/08/94 - Allow all extended screen modes.
    if( (mode & 0xFF) == smMono )       // Strip smFont8x8 if necessary.
        mode = smMono;

    return mode;

    /*
    if( (mode & 0xFF) == smMono )       // Strip smFont8x8 if necessary.
        return smMono;

    _AX = mode;
    if( _AL != smCO80 && _AL != smBW80 )
        _AL = smCO80;
    return _AX;
   */

}

void TScreen::setCrtData()
{
    screenMode = getCrtMode();
    screenWidth = getCols();
    screenHeight = getRows();
    hiResScreen = Boolean(screenHeight > 25);

#if !defined(__FLAT__)
    if( screenMode == smMono )
        {
        screenBuffer = THardwareInfo::getMonoAddr();
        checkSnow = False;
        }
    else
        {
        screenBuffer = THardwareInfo::getColorAddr();
        if( isEGAorVGA() )
            checkSnow = False;
        }
#endif

    cursorLines = getCursorType();
    setCursorType( 0 );
}

void TScreen::clearScreen()
{
    TDisplay::clearScreen( screenWidth, screenHeight );
}

void TScreen::setVideoMode( ushort mode )
{
    setCrtMode( fixCrtMode( mode ) );
    setCrtData();

    if (TMouse::present())
        TMouse::setRange( getCols()-1, getRows()-1 );
}
